﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp2
{

    class Car
    {
        string brand;
        string model;
        int year;

        public static int counter = 0;

        public string Brand
        {
            get { return brand; }
            set { brand = value; }
        }

        public string Model
        {
            get { return model; }
            set { model = value; }
        }

        public int Year
        {
            get { return year; }
            set { year = value; }
        }

        public Car(string brand, string model, int year)
        {
            Brand = brand;
            Model = model;
            Year = year;
            counter++;
        }

        public virtual void PrintCarInfo()
        {
            Console.WriteLine($"Brand : {brand}");
            Console.WriteLine($"Model : {model}");
            Console.WriteLine($"Year : {year}");
            Console.WriteLine("-----------------------------");
        }

    }

    class ElectricCar : Car
    {
        int batterySize;

        public int BatterySize
        {
            get { return batterySize; }
            set { batterySize = value; }
        }

        public ElectricCar(string brand, string model, int year, int batterySize) : base(brand, model, year)
        {
            BatterySize = batterySize;
        }

        public override void PrintCarInfo()
        {
            base.PrintCarInfo();
            Console.WriteLine($"Battery Size : {BatterySize}");
            Console.WriteLine("-----------------------------");
        }


    }
    internal class Program
    {
        static void Main(string[] args)
        {
            Car[] cars = new Car[2];
            cars [0] = new Car("Toyota", "i don't know", 2017);
            cars [1] = new ElectricCar("Tesla", "i don't know", 2022, 180);

            foreach (Car car in cars)
            {
                car.PrintCarInfo();
            }
        }
    }
}
