﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp3
{

    abstract class Vehicle
    {
        public abstract void Move();
    }
    class Car : Vehicle
    {
        string brand;
        string model;
        int year;

        public static int counter = 0;

        public string Brand
        {
            get { return brand; }
            set { brand = value; }
        }

        public string Model
        {
            get { return model; }
            set { model = value; }
        }

        public int Year
        {
            get { return year; }
            set { year = value; }
        }

        public Car(string brand, string model, int year)
        {
            Brand = brand;
            Model = model;
            Year = year;
            counter++;
        }

        public virtual void PrintCarInfo()
        {
            Console.WriteLine($"Brand : {brand}");
            Console.WriteLine($"Model : {model}");
            Console.WriteLine($"Year : {year}");
            Console.WriteLine("-----------------------------");
        }

        public override void Move()
        {
            Console.WriteLine("The car is Moving ... ");
        }
    }

    class ElectricCar : Car
    {
        int batterySize;

        public int BatterySize
        {
            get { return batterySize; }
            set { batterySize = value; }
        }

        public ElectricCar(string brand, string model, int year, int batterySize) : base(brand, model, year)
        {
            BatterySize = batterySize;
        }

        public override void Move()
        {
            Console.WriteLine("The Electric car is Moving ... ");
        }


    }


    internal class Program
    {
        static void Main(string[] args)
        {
            Car car01 = new Car("Toyota", "i don't Know", 2005);
            ElectricCar car02 = new ElectricCar("Tesla", "i don't Know", 2012, 150);

            car01.Move();
            car02.Move();
        }
    }
}
