﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp4
{

    public interface IChargeable
    {
        void ChargeBattery();
    }
    class Car
    {
        string brand;
        string model;
        int year;

        public static int counter = 0;

        public string Brand
        {
            get { return brand; }
            set { brand = value; }
        }

        public string Model
        {
            get { return model; }
            set { model = value; }
        }

        public int Year
        {
            get { return year; }
            set { year = value; }
        }

        public Car(string brand, string model, int year)
        {
            Brand = brand;
            Model = model;
            Year = year;
            counter++;
        }

        public virtual void PrintCarInfo()
        {
            Console.WriteLine($"Brand : {brand}");
            Console.WriteLine($"Model : {model}");
            Console.WriteLine($"Year : {year}");
            Console.WriteLine("-----------------------------");
        }
    }

    class ElectricCar : Car , IChargeable 
    {
        int batterySize;
        int chargeLevel;

        public int BatterySize
        {
            get { return batterySize; }
            set { batterySize = value; }
        }

        public int ChargeLevel
        {
            get { return chargeLevel; }
            set { chargeLevel = value; }
        }

        public ElectricCar(string brand, string model, int year, int batterySize, int chargeLevel) : base(brand, model, year)
        {
            BatterySize = batterySize;
            ChargeLevel = chargeLevel;
        }

        public override void PrintCarInfo()
        {
            base.PrintCarInfo();
            Console.WriteLine($"Battery Size : {BatterySize} kWh");
            Console.WriteLine($"Current Charge Level : {ChargeLevel}%");
            Console.WriteLine("-----------------------------");
        }

        public void ChargeBattery()
        {
            int remaining = 100 - ChargeLevel;

            if (remaining == 0)
            {
                Console.WriteLine("Battery is already fully charged!");
            }
            else
            {
                Console.WriteLine($"Charging... You need {remaining}% to reach full charge");
            }
        
        }

    }
    internal class Program
    {
        static void Main(string[] args)
        {

            ElectricCar tesla = new ElectricCar("Tesla", "i don't Know", 2024, 150, 60);
            
            tesla.PrintCarInfo();
            tesla.ChargeBattery();

        }
    }
}
